// Injection Wizard
// --An application for injecting traffic in WEP protected Wi-Fi networks--
// Version: 1.0
// Copyright (C) 2010 Fernando Pablo Romero Navarro <fernpromero@gmail.com>
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

package cliente;

import java.io.*;
import java.util.*;
import javax.swing.SwingUtilities;


public class Main {

    private final static String TEXTFILENAME="uitxt";

    public static void main(String[] args){
        ClientConf cliconf=null;
        ResourceBundle bundle=null;
        Properties props=null;        
        String lng=null;

        try{
            MsgOptParser.init();
            props=PropertyManager.loadProperties();
            if(props==null)
                throw new FileNotFoundException(PropertyManager.propfilename);

            lng=props.getProperty(PropertyManager.LNG);
            if(lng==null){
                lng="english";
                props.put(PropertyManager.LNG, lng);
            }else
                lng=lng.toLowerCase();

            Locale local=null;
            if(lng.equals("spanish"))
                local=new Locale("es", "ES");
            else
                local=new Locale("en", "US");


            String suffix=local.getLanguage();
            if(suffix.length()>1)
                suffix="_"+suffix+".properties";
            else
                suffix=".properties";
            
            InputStream is=null;
            is=Main.class.getResourceAsStream(TEXTFILENAME+suffix);
            if(is==null)
                throw new FileNotFoundException(TEXTFILENAME+suffix);
            
            Reader reader=new InputStreamReader(is, "UTF-8");
            bundle=new PropertyResourceBundle(reader);
            reader.close();

            cliconf=new ClientConf();
            cliconf.load(props);
            final MainWindow window=new MainWindow(cliconf, bundle);
            
            SwingUtilities.invokeAndWait(new Runnable(){
                                            public void run(){
                                                window.initialStage();
                                                window.contact_init(false);
                                                window.setVisible(true);
                                                window.showAnnouncement();
                                            }
                                        });           
            
        }catch(FileNotFoundException fnf){
            if(props==null)
                System.err.println("Property file cannot be opened:");
            else
                System.err.println("Localization file cannot be opened:");
            
            fnf.printStackTrace(System.err);
        }catch(Exception e){
            System.err.println("Unrecoverable error:");
            e.printStackTrace(System.err);
        }
    }
}
